Debian Bug report logs - #731999
typo3-src: TYPO3-CORE-SA-2013-004

version graph

Package: typo3-src; Maintainer for typo3-src is Christian Welzel <gawain@camlann.de>;

Reported by: Henri Salo <henri@nerv.fi>

Date: Thu, 12 Dec 2013 07:51:02 UTC

Severity: important

Tags: fixed-upstream, security

Found in versions 4.5.30+dfsg1-2, 4.5.19+dfsg1-5

Fixed in versions typo3-src/4.5.32+dfsg1-1, typo3-src/4.5.19+dfsg1-5+wheezy2, typo3-src/4.3.9+dfsg1-1+squeeze9

Done: Salvatore Bonaccorso <carnil@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Christian Welzel <gawain@camlann.de>:
Bug#731999; Package typo3-src. (Thu, 12 Dec 2013 07:51:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Henri Salo <henri@nerv.fi>:
New Bug report received and forwarded. Copy sent to Christian Welzel <gawain@camlann.de>. (Thu, 12 Dec 2013 07:51:06 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Henri Salo <henri@nerv.fi>
To: submit@bugs.debian.org
Subject: typo3-src: TYPO3-CORE-SA-2013-004
Date: Thu, 12 Dec 2013 09:46:46 +0200
[Message part 1 (text/plain, inline)]
Package: typo3-src
Version: 4.5.30+dfsg1-2
Severity: important
Tags: fixed-upstream, security

Following vulnerabilities was published for TYPO3 and a bit special issue also
fixed at the same time.

http://typo3.org/teams/security/security-bulletins/typo3-core/typo3-core-sa-2013-004/
http://typo3.org/teams/security/security-bulletins/typo3-flow/typo3-flow-sa-2013-001/

CVE request http://www.openwall.com/lists/oss-security/2013/12/11/5

Please use following CVEs in changelog:

CVE-2013-7073
CVE-2013-7074
CVE-2013-7075
CVE-2013-7076
CVE-2013-7077
CVE-2013-7078
CVE-2013-7079
CVE-2013-7080
CVE-2013-7081
CVE-2013-7082

I'm happy to help if there is any questions about these issues.

---
Henri Salo
[signature.asc (application/pgp-signature, inline)]

Reply sent to Christian Welzel <gawain@camlann.de>:
You have taken responsibility. (Fri, 13 Dec 2013 17:51:12 GMT) Full text and rfc822 format available.

Notification sent to Henri Salo <henri@nerv.fi>:
Bug acknowledged by developer. (Fri, 13 Dec 2013 17:51:12 GMT) Full text and rfc822 format available.

Message #10 received at 731999-close@bugs.debian.org (full text, mbox):

From: Christian Welzel <gawain@camlann.de>
To: 731999-close@bugs.debian.org
Subject: Bug#731999: fixed in typo3-src 4.5.32+dfsg1-1
Date: Fri, 13 Dec 2013 17:49:29 +0000
Source: typo3-src
Source-Version: 4.5.32+dfsg1-1

We believe that the bug you reported is fixed in the latest version of
typo3-src, which is due to be installed in the Debian FTP archive.

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 731999@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Christian Welzel <gawain@camlann.de> (supplier of updated typo3-src package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@ftp-master.debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA512

Format: 1.8
Date: Fri, 13 Dec 2013 20:08:14 +0100
Source: typo3-src
Binary: typo3-src-4.5 typo3-database typo3-dummy typo3
Architecture: source all
Version: 4.5.32+dfsg1-1
Distribution: unstable
Urgency: medium
Maintainer: Christian Welzel <gawain@camlann.de>
Changed-By: Christian Welzel <gawain@camlann.de>
Description: 
 typo3      - web content management system (meta)
 typo3-database - web content management system (database)
 typo3-dummy - web content management system (basic site structure)
 typo3-src-4.5 - web content management system (core)
Closes: 731999
Changes: 
 typo3-src (4.5.32+dfsg1-1) unstable; urgency=medium
 .
   * New upstream release:
     - fixes: "TYPO3-CORE-SA-2013-004: Multiple Vulnerabilities in
       TYPO3 CMS" (Closes: #731999)
Checksums-Sha1: 
 d7bbc34293ce20c448330c505ca20d30a4547405 2033 typo3-src_4.5.32+dfsg1-1.dsc
 e51b038056bc5781f50cdc64d89e3eb2f74acac2 20365322 typo3-src_4.5.32+dfsg1.orig.tar.gz
 e026343de11be388712a4dbaaaeb153a8d102f74 404936 typo3-src_4.5.32+dfsg1-1.debian.tar.gz
 09f102863d7dd2b4a6fa6a8200dd3dfc7d1db527 20250910 typo3-src-4.5_4.5.32+dfsg1-1_all.deb
 da10089320f9d6878c67b5a0092fdad1f969402a 374472 typo3-database_4.5.32+dfsg1-1_all.deb
 3fa471c29a769ca5a702440496e710ce47f9dd75 383104 typo3-dummy_4.5.32+dfsg1-1_all.deb
 553bc7e4f70df35ef588389d4c0281a45b591b62 1386 typo3_4.5.32+dfsg1-1_all.deb
Checksums-Sha256: 
 1cbfc9856d4fda06f766e0c9581963583cb9c9dc3265c19b0344b4a6ca62e79d 2033 typo3-src_4.5.32+dfsg1-1.dsc
 967c4799b55768ba18796e8e9b84d8a7c5cc04305cf63e319f7f9be2a463ebf9 20365322 typo3-src_4.5.32+dfsg1.orig.tar.gz
 3d77525356ab1ddcad85ac94928507f9a0ad02f426a51a853efe4aaff6632001 404936 typo3-src_4.5.32+dfsg1-1.debian.tar.gz
 9b218c8105277949ac9428f3158f2179fd2c7d0559d4a5dd9ff4f16044adf5ec 20250910 typo3-src-4.5_4.5.32+dfsg1-1_all.deb
 5b6c9ff5f3ab5efe69bbab33661f5a4f763aca70ac1cdeeea05392772ae29918 374472 typo3-database_4.5.32+dfsg1-1_all.deb
 edf8649679f002f2498bec828e3276ff0146f85f557d81cc7e0ef216cd68ffdc 383104 typo3-dummy_4.5.32+dfsg1-1_all.deb
 b347a30b5e21df8ad72c967a67c08189c2f3a23e4a6d4a9a091d75e5eda94076 1386 typo3_4.5.32+dfsg1-1_all.deb
Files: 
 0702332a80c3195c59c5843a12a1bdf4 2033 web optional typo3-src_4.5.32+dfsg1-1.dsc
 829524cae128dcb7c9116316a5523c57 20365322 web optional typo3-src_4.5.32+dfsg1.orig.tar.gz
 fafa63a131482cba43d3ab0fb67eebc3 404936 web optional typo3-src_4.5.32+dfsg1-1.debian.tar.gz
 623cfc37eb80bfbb834bd9d73a641e7a 20250910 web optional typo3-src-4.5_4.5.32+dfsg1-1_all.deb
 2acd9c0da505e934a59265982780099f 374472 web optional typo3-database_4.5.32+dfsg1-1_all.deb
 76867b73550868f0aba34e9679868a2f 383104 web optional typo3-dummy_4.5.32+dfsg1-1_all.deb
 0bbca1fe2c752604cb0992fd8cd4a0cd 1386 web optional typo3_4.5.32+dfsg1-1_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iQIVAwUBUqtDmo1SzelRF+EZAQqBLhAAg6/+dKRUVoorQ9YAhblsJ4eJLhcv8meI
35QXU78PQ2ICDABi5Vs+P5KmRDgfkkO0LxI395pfu2GM/9MAlZwU6usx3/XNlQ9w
iptxd+OhcCvo8wKBTLYcQrKICKT4a8Z89Xipah1oo3wjMKko1/XCAkhboHpcrrez
u+JzduVroJ/itA4V7pkqSN1hEjlZsqcp3nr4kcyl+9yR1AQt2t7zeogV23O9ekAc
ZBbi6U/6R3+LYgkMIknXTvmfu1vNGFywGVCI56Qga7Sn3ZN0B/+3zoUU1kH//wZZ
9HsIQ1D4ru1SoLhgKeaPv4ObxqzPvNr6eopJtXRhzEPeAs6hhWg/4EdPC4bZcf0W
5AXf0U0YuAuNcLpgZSmGsNV+kPHJUPiJnsqcIpdLF0Rl5ngftgeK0jgtGUr8iH/s
7hAkhWPoVboAaWVFiqC3r0fcTGn0UcDC86mPXnfxhalc+9+5BaKC4hi9zK6vmIl8
SlYhXXQRcaBxsrXjeWHm4Zg9S4e7pvVTxxXgafsz/4PT80L624wr69Np5qRNZbyM
byib0GvkhjkbpaEZBvEwktuB+DE0Eg3VZPZYpzm/elQxLNf/5SsT7G5GPskyY8Pz
ByxODb/fSJRJxNsON0IeTUAD5QgXmcLW8+kGbvWj/+Kbslywt7NGu9kfjG+os7MR
00AO7nqADuw=
=jK0T
-----END PGP SIGNATURE-----




Marked as found in versions 4.5.19+dfsg1-5. Request was from Christian Welzel <gawain@camlann.de> to control@bugs.debian.org. (Sat, 14 Dec 2013 08:42:10 GMT) Full text and rfc822 format available.

Reply sent to Salvatore Bonaccorso <carnil@debian.org>:
You have taken responsibility. (Mon, 06 Jan 2014 22:51:13 GMT) Full text and rfc822 format available.

Notification sent to Henri Salo <henri@nerv.fi>:
Bug acknowledged by developer. (Mon, 06 Jan 2014 22:51:13 GMT) Full text and rfc822 format available.

Message #17 received at 731999-close@bugs.debian.org (full text, mbox):

From: Salvatore Bonaccorso <carnil@debian.org>
To: 731999-close@bugs.debian.org
Subject: Bug#731999: fixed in typo3-src 4.5.19+dfsg1-5+wheezy2
Date: Mon, 06 Jan 2014 22:47:58 +0000
Source: typo3-src
Source-Version: 4.5.19+dfsg1-5+wheezy2

We believe that the bug you reported is fixed in the latest version of
typo3-src, which is due to be installed in the Debian FTP archive.

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 731999@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Salvatore Bonaccorso <carnil@debian.org> (supplier of updated typo3-src package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@ftp-master.debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA512

Format: 1.8
Date: Fri, 13 Dec 2013 20:02:05 +0100
Source: typo3-src
Binary: typo3-src-4.5 typo3-database typo3-dummy typo3
Architecture: source all
Version: 4.5.19+dfsg1-5+wheezy2
Distribution: wheezy-security
Urgency: high
Maintainer: Christian Welzel <gawain@camlann.de>
Changed-By: Salvatore Bonaccorso <carnil@debian.org>
Description: 
 typo3      - web content management system (meta)
 typo3-database - web content management system (database)
 typo3-dummy - web content management system (basic site structure)
 typo3-src-4.5 - web content management system (core)
Closes: 731999
Changes: 
 typo3-src (4.5.19+dfsg1-5+wheezy2) wheezy-security; urgency=high
 .
   * Added patch for TYPO3-SA-2013-004. (Closes: #731999)
   * Set patch level version to -pl.4.5.32.
   * Added debian/gbp.conf.
Checksums-Sha1: 
 46974303bc57449ad4af0b2ade645a7805be74f6 2096 typo3-src_4.5.19+dfsg1-5+wheezy2.dsc
 c3ead8bfddd54497095a99fda8f41ea3a39dc3fd 435132 typo3-src_4.5.19+dfsg1-5+wheezy2.debian.tar.gz
 bd8064bfb415a46f1c9c81a31bf8af364e42f0e1 20096356 typo3-src-4.5_4.5.19+dfsg1-5+wheezy2_all.deb
 ba5b9abaa26f6a5a590352742f01f7f00ab67de3 283874 typo3-database_4.5.19+dfsg1-5+wheezy2_all.deb
 0023f0657a4b7a0568d277b67ecf23c484e96f99 291242 typo3-dummy_4.5.19+dfsg1-5+wheezy2_all.deb
 de83080b338cfb8c7b2f7d8d7fbb41432da62c9c 1388 typo3_4.5.19+dfsg1-5+wheezy2_all.deb
Checksums-Sha256: 
 52d636bdc24ccea46954d8fcae97a10ea6211a2dc09f26f2cc19b9a71a61d6d2 2096 typo3-src_4.5.19+dfsg1-5+wheezy2.dsc
 0d20434d26cab8361b4134606edc283c31e5ca573738248e920b22b068209be8 435132 typo3-src_4.5.19+dfsg1-5+wheezy2.debian.tar.gz
 f2840d4e262d84b404c1f2c24d3002913adafb10c6b80da9a797ed0e9e290c84 20096356 typo3-src-4.5_4.5.19+dfsg1-5+wheezy2_all.deb
 cbe6d18480e460a394f6cea73b4472d0f85265a0d191b97d9b50e5b53af6483d 283874 typo3-database_4.5.19+dfsg1-5+wheezy2_all.deb
 f8e830477c2ed76d54e1ea7b51552ef8937f6aec9e535f755aaf00562a53b88d 291242 typo3-dummy_4.5.19+dfsg1-5+wheezy2_all.deb
 b161f55349eb20c29de1abcb8975436e498f307122198093a033976a0cd65ea0 1388 typo3_4.5.19+dfsg1-5+wheezy2_all.deb
Files: 
 43038d7fb05b4b08f92437dafcd9cf37 2096 web optional typo3-src_4.5.19+dfsg1-5+wheezy2.dsc
 f8e238dd4d0d4980bc83a6f31291284c 435132 web optional typo3-src_4.5.19+dfsg1-5+wheezy2.debian.tar.gz
 6a51abb6c4c9caa640d0766d27982af6 20096356 web optional typo3-src-4.5_4.5.19+dfsg1-5+wheezy2_all.deb
 00b9071dfbf3cc8fc45a00b6ad33fbd7 283874 web optional typo3-database_4.5.19+dfsg1-5+wheezy2_all.deb
 2f896c08b247bfb9efff5b187e3e88ac 291242 web optional typo3-dummy_4.5.19+dfsg1-5+wheezy2_all.deb
 7971839779e96a7b4039aeeceb3e9e04 1388 web optional typo3_4.5.19+dfsg1-5+wheezy2_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iQIcBAEBCgAGBQJSwBnnAAoJEAVMuPMTQ89EhUUP/RJV27ablLXjaz+0EN4etk5I
1N1puU3ivysU3rz4wP8DXCccgagEh8fRoei65R9D4qEAYJ70pP2OG9iKoENvksOl
PqgWCeMgcZywq6wjZ+pZ8jnLaHxbOwcJ1iu4RXiX55XJhA5V8atdFt89EeXkjVl7
rBxSyNJeWrp6USybKP2s1WHHxLO3ZjZZBqyi1AAFG4nt4Mo3amrnFB5amQJd3sx3
In8vEH/WB8BlaSv0H6/VU8NXmAzKgSynA20zAKBSpo6rFDh4HOcIPol7bN+3mqxp
TJeQ49Uncshw3amFwdPdNyHdwoxIGvk1/vVJn65Vx7HFb4dMdbYiIi/hEhABh+No
JMtBmwxQSjTIHloOVDCDlg1+Qinj9Li2NPRVhowodmHwb9uyRNiiVfXgANnzbZ6z
xTetYwittpK86LmWD8boVG1hlpky7cxkpOQ23GDdRZDLY+upNaSHvJ2QCRUG54vG
EenKR7lMle7Vc2KiPEsjo0gtC2oZAQV73ZcJEm/ajUkTZSuCTC7Z1hBhEZ8HSDPv
RuzvY9qE5MHYQ8eEh36nv8quX40uVfDeuyAins2KPtDXJTYMdTUIorMfE+VPqSxT
p1XElvBh0kI6PIADgXaIVhNxmrkYjAD/GUbadf7VLcs/y0sEkhLEtkLjmsfpEhmV
5yJRldZ2mIg99na0n5yj
=f+6L
-----END PGP SIGNATURE-----




Reply sent to Salvatore Bonaccorso <carnil@debian.org>:
You have taken responsibility. (Mon, 06 Jan 2014 22:51:17 GMT) Full text and rfc822 format available.

Notification sent to Henri Salo <henri@nerv.fi>:
Bug acknowledged by developer. (Mon, 06 Jan 2014 22:51:17 GMT) Full text and rfc822 format available.

Message #22 received at 731999-close@bugs.debian.org (full text, mbox):

From: Salvatore Bonaccorso <carnil@debian.org>
To: 731999-close@bugs.debian.org
Subject: Bug#731999: fixed in typo3-src 4.3.9+dfsg1-1+squeeze9
Date: Mon, 06 Jan 2014 22:48:35 +0000
Source: typo3-src
Source-Version: 4.3.9+dfsg1-1+squeeze9

We believe that the bug you reported is fixed in the latest version of
typo3-src, which is due to be installed in the Debian FTP archive.

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 731999@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Salvatore Bonaccorso <carnil@debian.org> (supplier of updated typo3-src package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@ftp-master.debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA512

Format: 1.8
Date: Wed, 18 Dec 2013 18:40:09 +0100
Source: typo3-src
Binary: typo3-src-4.3 typo3-database typo3
Architecture: source all
Version: 4.3.9+dfsg1-1+squeeze9
Distribution: squeeze-security
Urgency: high
Maintainer: Christian Welzel <gawain@camlann.de>
Changed-By: Salvatore Bonaccorso <carnil@debian.org>
Description: 
 typo3      - The enterprise level open source WebCMS (Meta)
 typo3-database - TYPO3 - The enterprise level open source WebCMS (Database)
 typo3-src-4.3 - TYPO3 - The enterprise level open source WebCMS (Core)
Closes: 731999
Changes: 
 typo3-src (4.3.9+dfsg1-1+squeeze9) squeeze-security; urgency=high
 .
   * Security patch backported from new upstream release 4.5.32:
     - fixes: "TYPO3 Security Bulletin TYPO3-CORE-SA-2013-004:
       Several Vulnerabilities in TYPO3 Core" (Closes: 731999)
   * Added gbp.conf.
Checksums-Sha1: 
 dd71eb69a324aab0e4a2403c3fd0aba6ce6f0e7c 1748 typo3-src_4.3.9+dfsg1-1+squeeze9.dsc
 ac5745408c5196bbfb5a141625a8ec354ee55b54 155443 typo3-src_4.3.9+dfsg1-1+squeeze9.debian.tar.gz
 5b2df2abd337e14e4e7127eab64c6ab35c674a9a 11292182 typo3-src-4.3_4.3.9+dfsg1-1+squeeze9_all.deb
 af75edaf929cfba53fda56ef3f79613e7395e5b9 202850 typo3-database_4.3.9+dfsg1-1+squeeze9_all.deb
 c67b8e3706edf90528c22dcffcb6d9b00d19a14d 1260 typo3_4.3.9+dfsg1-1+squeeze9_all.deb
Checksums-Sha256: 
 50375ce5a7c819fbccf604a28b76bb54444e2595f45beba5092043211139d995 1748 typo3-src_4.3.9+dfsg1-1+squeeze9.dsc
 df5ec1b49895e3a98af4a0475eef13d74a79c64c06eb2dbafde94a8fd18ce103 155443 typo3-src_4.3.9+dfsg1-1+squeeze9.debian.tar.gz
 cc452940725be2fd62f4fd6534e18be11be91dec972e89f8e487b3700654e784 11292182 typo3-src-4.3_4.3.9+dfsg1-1+squeeze9_all.deb
 59eb19fb22587c30aecf77f18f21e37d3611314588fa6a29294d868c2122013b 202850 typo3-database_4.3.9+dfsg1-1+squeeze9_all.deb
 31e603d067389368e2df6bdf52fd66bcf75ed7221b336d318d83c33f83ea0e83 1260 typo3_4.3.9+dfsg1-1+squeeze9_all.deb
Files: 
 81055cba860f309cad0dfb752cfd4ae5 1748 web optional typo3-src_4.3.9+dfsg1-1+squeeze9.dsc
 89e7a0500ed61e9310ef4e3403dc028b 155443 web optional typo3-src_4.3.9+dfsg1-1+squeeze9.debian.tar.gz
 fe29513291e0de4a18fa6441bf0cf31c 11292182 web optional typo3-src-4.3_4.3.9+dfsg1-1+squeeze9_all.deb
 389554b5220ac27dd17470ac5b3e7279 202850 web optional typo3-database_4.3.9+dfsg1-1+squeeze9_all.deb
 52ace7aca9b4324c2dd802a143c7cd9d 1260 web optional typo3_4.3.9+dfsg1-1+squeeze9_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iQIcBAEBCgAGBQJSwC7gAAoJEAVMuPMTQ89Ei3QP/39GQFxHPPMQzdAn9h2BMLaV
0gT2VXckqkxzKFpoEB6/yKFsYr94UvRl7frWUgH8CH4Wf1BG2/V+Ne3xe5b3wuTU
ZXNtyIWtD0OcfslPGoQbl4555W2uHDwOTyCufKhyBr2X8/a9K2g7Ra30OYxTAmhd
AKWUHHF9XS3gy/K8DOfVl+beeQavlxkKCYHnq4ogSguQdQHRl7aeGW/H3DL1Yi4I
Mg3V1tb4KsLD9AhDJuOF6Uf2L7sDHDRaWwn6GyiiYjsyo+l5F3tuvnJrAfg0i0ew
hEMUKYaKPlpqwf6ieYnICZ/kD1mTTyv+QyJBuzxPc4UTIMw52s7Sx5c1Hk+UeEme
xrx7OVMZa1Q1Pxc8pJVwZ5jpnCIiCfL7Pg80efjszfx4kTrLchQFuAcbAaZMPqbw
3V44d4Vy0GNh47KqVWVTH4TQJ3R5OiHXYN/K+p9goJQ5/sscPZsavLJ/vMd4U/Lh
cbJHdGEWA4UHyp7wEpwv72Tb488WnnSVEBiy/q+Waofv41U2+7hmDy+kZY+MQGRk
+qjpYsgbsKMUlWFq1bDfwXJqWB4Rh39LRPwHbBXRe6hFpqBqxQTmzt5CwGTBD2Gq
rAzcDBggGBALmO0E1iaKqcVf8upJIFJ9YXHKdqlPak9fzilg/F70TMkCY6ykkAak
oiove/7+MFjKWCZ7pnE6
=F6Zt
-----END PGP SIGNATURE-----




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Tue, 04 Feb 2014 07:32:26 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Mon Apr 21 06:39:27 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.